package thehippomaster.animationapi.anim;

import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAIBase;
import thehippomaster.animationapi.AnimationAPI;

public abstract class AIAnimation extends EntityAIBase {
    private IAnimatedEntity animatedEntity;

    public AIAnimation(IAnimatedEntity entity) {
        this.animatedEntity = entity;
        this.func_75248_a(7);
    }

    public abstract int getAnimID();

    public <T extends EntityLiving> EntityLiving getEntity() {
        return (EntityLiving)this.animatedEntity;
    }

    public abstract boolean isAutomatic();

    public abstract int getDuration();

    public boolean shouldAnimate() {
        return false;
    }

    public boolean func_75250_a() {
        if (this.isAutomatic()) {
            return this.animatedEntity.getAnimID() == this.getAnimID();
        } else {
            return this.shouldAnimate();
        }
    }

    public void func_75249_e() {
        if (!this.isAutomatic()) {
            AnimationAPI.sendAnimPacket(this.animatedEntity, this.getAnimID());
        }

        this.animatedEntity.setAnimTick(0);
    }

    public boolean continueExecuting() {
        return this.animatedEntity.getAnimTick() < this.getDuration();
    }

    public void func_75251_c() {
        AnimationAPI.sendAnimPacket(this.animatedEntity, 0);
    }
}
