package thehippomaster.animationapi.client.model.wavefront;

import thehippomaster.animationapi.util.ModReference;

import java.util.HashMap;

public class WavefrontAPI
{
  private HashMap<String, WavefrontModel> modelRegistry;
  
  public WavefrontAPI()
  {
    this.modelRegistry = new HashMap();
  }
  
  public static WavefrontAPI instance()
  {
    return instance;
  }
  
  public WavefrontModel loadModel(String path)
  {
    WavefrontModel model = new WavefrontModel();
    if (model.load(path))
    {
      String tag = path.replaceAll(".obj", "").replaceAll(".OBJ", "");
      tag = tag.substring(tag.lastIndexOf('/') + 1, tag.length());
      this.modelRegistry.put(tag, model);
      ModReference.LOGGER.info("[ArsenalMod] Loaded new model: "+tag);
    }
    return model;
  }
  
  public static WavefrontModel getModel(String modelName)
  {
    return (WavefrontModel)instance().modelRegistry.get(modelName);
  }
  
  public static Part getPart(String modelName, String partName)
  {
    WavefrontModel model = getModel(modelName);
    return model != null ? model.getPart(partName) : null;
  }
  
  public static boolean renderPart(String modelName, String partName)
  {
    Part part = getPart(modelName, partName);
    if (part != null)
    {
      part.draw();
      return true;
    }
    return false;
  }
  
  public HashMap<String, WavefrontModel> getModelRegistry()
  {
    return this.modelRegistry;
  }
  
  private static WavefrontAPI instance = new WavefrontAPI();
}
